#include "mpii.h"

static char *strings[MPII_MAX_ERROR+1] = {
   /* MPI_SUCCESS */           "No error (success)",
   /* MPII_NOT_INITIALIZED */  "MPI_Init() not called",
   /* MPII_BAD_ERRORCODE */    "Invalid errorcode argument",
   /* MPII_OUT_OF_MEMORY */    "Out of memory (malloc failed)",
   /* MPII_INIT_ARG */         "MPI_Init: Master arguments are missing/invalid",
   /* MPII_ACTIVE_REQ */       "MPI_Start: Active request",
   /* MPII_REQUEST_NULL */     "MPI_Start: REQUEST_NULL",
   /* MPII_RANK_RANGE */       "Rank is out of [0, communicator size]",
   /* MPII_TYPE_MISMATCH */    "Datatype mismatch between send and receive",
   /* MPII_OVERFLOW */         "Receive truncated data to specified amount",
   /* MPII_INACTIVE_REQ */     "MPI_Wait: Inactive request"
};

PUBLIC int MPI_Error_string (int errorcode, char *string, int *resultlen)
{
   if (errorcode < 0 || errorcode > MPII_MAX_ERROR)
      return MPII_Error (NULL, MPII_BAD_ERRORCODE);

   *resultlen = strlen (strings[errorcode]);
   strncpy (string, strings[errorcode], *resultlen);

   return MPI_SUCCESS;
}

