#include "mpii.h"

PUBLIC int MPI_Ssend_init (void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request)
{
   if (dest < 0 || dest > comm->group->size)
      return MPII_Error (comm, MPII_RANK_RANGE);

   request->active = 0;
   request->persistent = 1;
   request->type = MPII_REQUEST_SSEND;
   request->comm = comm;
   request->buf = buf;
   request->count = count;
   request->datatype = datatype;
   request->srcdest = dest;
   request->tag = tag;

   return MPI_SUCCESS;
}

